<form [formGroup]="userForm" (ngSubmit)="onSaveUserProfile()">
  <div class="form-group">
    <div class="form-group__header">
      <h3 class="form-group__title">User Profile</h3>
    </div>
    <div class="form-group__content">
      <div class="form-group__row">

        <div class="form-group__column">
          <mat-form-field appearance="outline">
            <mat-label>Name</mat-label>
            <input
              matInput
              type="text"
              formControlName="userName"
              required
            >
            <mat-error *ngIf="userForm.get('userName').hasError('required') && userForm.get('userName').touched">Name is required!</mat-error>
          </mat-form-field>
        </div>

        <div class="form-group__column">
          <mat-form-field appearance="outline">
            <mat-label>Organization</mat-label>
            <input
              matInput
              type="text"
              formControlName="companyName"
              autocomplete="off"
            >
          </mat-form-field>
        </div>

      </div>
    </div>
  </div>

  <div class="form-group">
    <div class="form-group__header">
      <h3 class="form-group__title">Contact Information</h3>
    </div>

    <div formArrayName="userInfoArray" class="form-group__content">
      <div class="form-group__row">
        <ng-container *ngFor="let userInfo of getUserInfoGroup(); index as index">
          <div class="form-group__column" [formGroupName]="index">
            <div class="form-group__row">
              <mat-form-field class="form-group__column" appearance="outline">
                <mat-label>Type of Contact</mat-label>
                <mat-select
                  formControlName="contactType"
                  disableOptionCentering
                  (selectionChange)="switchField($event, index)"
                >
                  <mat-option *ngFor="let type of contactTypes" [value]="type.type">{{type.text}}</mat-option>
                </mat-select>
              </mat-form-field>

              <mat-form-field class="form-group__column" appearance="outline">
                <mat-label>Contact Label</mat-label>
                <input
                  matInput
                  type="text"
                  formControlName="contactLabel"
                  required
                >
                <mat-error *ngIf="userInfo.get('contactLabel').hasError('required') && userInfo.get('contactLabel').touched">Label is required!</mat-error>
              </mat-form-field>
            </div>

            <mat-form-field *ngIf="userInfo.get('email')" appearance="outline">
              <mat-label>Email/Phone No.</mat-label>
              <input
                matInput
                type="text"
                formControlName="email"
                required
              >
              <mat-error *ngIf="!userInfo.get('email').valid && userInfo.get('email').touched">
                <span *ngIf="userInfo.get('email').hasError('required')">Email is required!</span>
                <span *ngIf="userInfo.get('email').hasError('email')">Email is not valid!</span>
              </mat-error>
            </mat-form-field>

            <mat-form-field *ngIf="userInfo.get('phone')" appearance="outline">
              <mat-label>Email/Phone No.</mat-label>
              <input
                matInput
                type="text"
                formControlName="phone"
                required
              >
              <mat-error *ngIf="!userInfo.get('phone').valid && userInfo.get('phone').touched">
                <span  *ngIf="userInfo.get('phone').hasError('required')">Phone No. is required!</span>
                <span *ngIf="!userInfo.get('phone').hasError('required') && userInfo.get('phone').hasError('invalidNumber')">Phone No. is not valid!</span>
              </mat-error>
            </mat-form-field>

            <div class="form-group__remove-item">
              <button mat-raised-button type="button" color="warn" (click)="onRemoveContact(index)">Remove</button>
            </div>
          </div>
        </ng-container>
        <div *ngIf="getUserInfoGroup()?.length === 0" class="form-group__add-contact-text">
          You can add a contact
        </div>
      </div>
    </div>
  </div>

  <div class="form-group">
    <div class="form-group__footer">
      <div class="form-group__row">
        <div class="form-group__column">
          <div class="form-group__btn-group">
            <button mat-raised-button
                    type="button"
                    color="primary"
                    (click)="onAddContacts()"
            >Add Contact</button>
            <button mat-raised-button
                    type="submit"
                    color="accent"
                    [disabled]="!userForm.valid"
            >Save User Profile</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</form>
